// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from gazebo_msgs:msg/ODEJointProperties.idl
// generated code does not contain a copyright notice

#ifndef GAZEBO_MSGS__MSG__DETAIL__ODE_JOINT_PROPERTIES__TRAITS_HPP_
#define GAZEBO_MSGS__MSG__DETAIL__ODE_JOINT_PROPERTIES__TRAITS_HPP_

#include "gazebo_msgs/msg/detail/ode_joint_properties__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

namespace rosidl_generator_traits
{

inline void to_yaml(
  const gazebo_msgs::msg::ODEJointProperties & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: damping
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.damping.size() == 0) {
      out << "damping: []\n";
    } else {
      out << "damping:\n";
      for (auto item : msg.damping) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: hi_stop
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.hi_stop.size() == 0) {
      out << "hi_stop: []\n";
    } else {
      out << "hi_stop:\n";
      for (auto item : msg.hi_stop) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: lo_stop
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.lo_stop.size() == 0) {
      out << "lo_stop: []\n";
    } else {
      out << "lo_stop:\n";
      for (auto item : msg.lo_stop) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: erp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.erp.size() == 0) {
      out << "erp: []\n";
    } else {
      out << "erp:\n";
      for (auto item : msg.erp) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: cfm
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.cfm.size() == 0) {
      out << "cfm: []\n";
    } else {
      out << "cfm:\n";
      for (auto item : msg.cfm) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: stop_erp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.stop_erp.size() == 0) {
      out << "stop_erp: []\n";
    } else {
      out << "stop_erp:\n";
      for (auto item : msg.stop_erp) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: stop_cfm
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.stop_cfm.size() == 0) {
      out << "stop_cfm: []\n";
    } else {
      out << "stop_cfm:\n";
      for (auto item : msg.stop_cfm) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: fudge_factor
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.fudge_factor.size() == 0) {
      out << "fudge_factor: []\n";
    } else {
      out << "fudge_factor:\n";
      for (auto item : msg.fudge_factor) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: fmax
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.fmax.size() == 0) {
      out << "fmax: []\n";
    } else {
      out << "fmax:\n";
      for (auto item : msg.fmax) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: vel
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.vel.size() == 0) {
      out << "vel: []\n";
    } else {
      out << "vel:\n";
      for (auto item : msg.vel) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const gazebo_msgs::msg::ODEJointProperties & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<gazebo_msgs::msg::ODEJointProperties>()
{
  return "gazebo_msgs::msg::ODEJointProperties";
}

template<>
inline const char * name<gazebo_msgs::msg::ODEJointProperties>()
{
  return "gazebo_msgs/msg/ODEJointProperties";
}

template<>
struct has_fixed_size<gazebo_msgs::msg::ODEJointProperties>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<gazebo_msgs::msg::ODEJointProperties>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<gazebo_msgs::msg::ODEJointProperties>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // GAZEBO_MSGS__MSG__DETAIL__ODE_JOINT_PROPERTIES__TRAITS_HPP_
