// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from gazebo_msgs:srv/GetWorldProperties.idl
// generated code does not contain a copyright notice

#ifndef GAZEBO_MSGS__SRV__DETAIL__GET_WORLD_PROPERTIES__TRAITS_HPP_
#define GAZEBO_MSGS__SRV__DETAIL__GET_WORLD_PROPERTIES__TRAITS_HPP_

#include "gazebo_msgs/srv/detail/get_world_properties__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

namespace rosidl_generator_traits
{

inline void to_yaml(
  const gazebo_msgs::srv::GetWorldProperties_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  (void)msg;
  (void)indentation;
  out << "null\n";
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const gazebo_msgs::srv::GetWorldProperties_Request & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<gazebo_msgs::srv::GetWorldProperties_Request>()
{
  return "gazebo_msgs::srv::GetWorldProperties_Request";
}

template<>
inline const char * name<gazebo_msgs::srv::GetWorldProperties_Request>()
{
  return "gazebo_msgs/srv/GetWorldProperties_Request";
}

template<>
struct has_fixed_size<gazebo_msgs::srv::GetWorldProperties_Request>
  : std::integral_constant<bool, true> {};

template<>
struct has_bounded_size<gazebo_msgs::srv::GetWorldProperties_Request>
  : std::integral_constant<bool, true> {};

template<>
struct is_message<gazebo_msgs::srv::GetWorldProperties_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

inline void to_yaml(
  const gazebo_msgs::srv::GetWorldProperties_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: sim_time
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sim_time: ";
    value_to_yaml(msg.sim_time, out);
    out << "\n";
  }

  // member: model_names
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.model_names.size() == 0) {
      out << "model_names: []\n";
    } else {
      out << "model_names:\n";
      for (auto item : msg.model_names) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: rendering_enabled
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "rendering_enabled: ";
    value_to_yaml(msg.rendering_enabled, out);
    out << "\n";
  }

  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    value_to_yaml(msg.success, out);
    out << "\n";
  }

  // member: status_message
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status_message: ";
    value_to_yaml(msg.status_message, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const gazebo_msgs::srv::GetWorldProperties_Response & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<gazebo_msgs::srv::GetWorldProperties_Response>()
{
  return "gazebo_msgs::srv::GetWorldProperties_Response";
}

template<>
inline const char * name<gazebo_msgs::srv::GetWorldProperties_Response>()
{
  return "gazebo_msgs/srv/GetWorldProperties_Response";
}

template<>
struct has_fixed_size<gazebo_msgs::srv::GetWorldProperties_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<gazebo_msgs::srv::GetWorldProperties_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<gazebo_msgs::srv::GetWorldProperties_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<gazebo_msgs::srv::GetWorldProperties>()
{
  return "gazebo_msgs::srv::GetWorldProperties";
}

template<>
inline const char * name<gazebo_msgs::srv::GetWorldProperties>()
{
  return "gazebo_msgs/srv/GetWorldProperties";
}

template<>
struct has_fixed_size<gazebo_msgs::srv::GetWorldProperties>
  : std::integral_constant<
    bool,
    has_fixed_size<gazebo_msgs::srv::GetWorldProperties_Request>::value &&
    has_fixed_size<gazebo_msgs::srv::GetWorldProperties_Response>::value
  >
{
};

template<>
struct has_bounded_size<gazebo_msgs::srv::GetWorldProperties>
  : std::integral_constant<
    bool,
    has_bounded_size<gazebo_msgs::srv::GetWorldProperties_Request>::value &&
    has_bounded_size<gazebo_msgs::srv::GetWorldProperties_Response>::value
  >
{
};

template<>
struct is_service<gazebo_msgs::srv::GetWorldProperties>
  : std::true_type
{
};

template<>
struct is_service_request<gazebo_msgs::srv::GetWorldProperties_Request>
  : std::true_type
{
};

template<>
struct is_service_response<gazebo_msgs::srv::GetWorldProperties_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // GAZEBO_MSGS__SRV__DETAIL__GET_WORLD_PROPERTIES__TRAITS_HPP_
