// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from gazebo_msgs:msg/WorldState.idl
// generated code does not contain a copyright notice
#include "gazebo_msgs/msg/detail/world_state__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `name`
#include "rosidl_runtime_c/string_functions.h"
// Member `pose`
#include "geometry_msgs/msg/detail/pose__functions.h"
// Member `twist`
#include "geometry_msgs/msg/detail/twist__functions.h"
// Member `wrench`
#include "geometry_msgs/msg/detail/wrench__functions.h"

bool
gazebo_msgs__msg__WorldState__init(gazebo_msgs__msg__WorldState * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    gazebo_msgs__msg__WorldState__fini(msg);
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__Sequence__init(&msg->name, 0)) {
    gazebo_msgs__msg__WorldState__fini(msg);
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__Sequence__init(&msg->pose, 0)) {
    gazebo_msgs__msg__WorldState__fini(msg);
    return false;
  }
  // twist
  if (!geometry_msgs__msg__Twist__Sequence__init(&msg->twist, 0)) {
    gazebo_msgs__msg__WorldState__fini(msg);
    return false;
  }
  // wrench
  if (!geometry_msgs__msg__Wrench__Sequence__init(&msg->wrench, 0)) {
    gazebo_msgs__msg__WorldState__fini(msg);
    return false;
  }
  return true;
}

void
gazebo_msgs__msg__WorldState__fini(gazebo_msgs__msg__WorldState * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // name
  rosidl_runtime_c__String__Sequence__fini(&msg->name);
  // pose
  geometry_msgs__msg__Pose__Sequence__fini(&msg->pose);
  // twist
  geometry_msgs__msg__Twist__Sequence__fini(&msg->twist);
  // wrench
  geometry_msgs__msg__Wrench__Sequence__fini(&msg->wrench);
}

bool
gazebo_msgs__msg__WorldState__are_equal(const gazebo_msgs__msg__WorldState * lhs, const gazebo_msgs__msg__WorldState * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__Sequence__are_equal(
      &(lhs->name), &(rhs->name)))
  {
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__Sequence__are_equal(
      &(lhs->pose), &(rhs->pose)))
  {
    return false;
  }
  // twist
  if (!geometry_msgs__msg__Twist__Sequence__are_equal(
      &(lhs->twist), &(rhs->twist)))
  {
    return false;
  }
  // wrench
  if (!geometry_msgs__msg__Wrench__Sequence__are_equal(
      &(lhs->wrench), &(rhs->wrench)))
  {
    return false;
  }
  return true;
}

bool
gazebo_msgs__msg__WorldState__copy(
  const gazebo_msgs__msg__WorldState * input,
  gazebo_msgs__msg__WorldState * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // name
  if (!rosidl_runtime_c__String__Sequence__copy(
      &(input->name), &(output->name)))
  {
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__Sequence__copy(
      &(input->pose), &(output->pose)))
  {
    return false;
  }
  // twist
  if (!geometry_msgs__msg__Twist__Sequence__copy(
      &(input->twist), &(output->twist)))
  {
    return false;
  }
  // wrench
  if (!geometry_msgs__msg__Wrench__Sequence__copy(
      &(input->wrench), &(output->wrench)))
  {
    return false;
  }
  return true;
}

gazebo_msgs__msg__WorldState *
gazebo_msgs__msg__WorldState__create()
{
  gazebo_msgs__msg__WorldState * msg = (gazebo_msgs__msg__WorldState *)malloc(sizeof(gazebo_msgs__msg__WorldState));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(gazebo_msgs__msg__WorldState));
  bool success = gazebo_msgs__msg__WorldState__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
gazebo_msgs__msg__WorldState__destroy(gazebo_msgs__msg__WorldState * msg)
{
  if (msg) {
    gazebo_msgs__msg__WorldState__fini(msg);
  }
  free(msg);
}


bool
gazebo_msgs__msg__WorldState__Sequence__init(gazebo_msgs__msg__WorldState__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  gazebo_msgs__msg__WorldState * data = NULL;
  if (size) {
    data = (gazebo_msgs__msg__WorldState *)calloc(size, sizeof(gazebo_msgs__msg__WorldState));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = gazebo_msgs__msg__WorldState__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        gazebo_msgs__msg__WorldState__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
gazebo_msgs__msg__WorldState__Sequence__fini(gazebo_msgs__msg__WorldState__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      gazebo_msgs__msg__WorldState__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

gazebo_msgs__msg__WorldState__Sequence *
gazebo_msgs__msg__WorldState__Sequence__create(size_t size)
{
  gazebo_msgs__msg__WorldState__Sequence * array = (gazebo_msgs__msg__WorldState__Sequence *)malloc(sizeof(gazebo_msgs__msg__WorldState__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = gazebo_msgs__msg__WorldState__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
gazebo_msgs__msg__WorldState__Sequence__destroy(gazebo_msgs__msg__WorldState__Sequence * array)
{
  if (array) {
    gazebo_msgs__msg__WorldState__Sequence__fini(array);
  }
  free(array);
}

bool
gazebo_msgs__msg__WorldState__Sequence__are_equal(const gazebo_msgs__msg__WorldState__Sequence * lhs, const gazebo_msgs__msg__WorldState__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!gazebo_msgs__msg__WorldState__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
gazebo_msgs__msg__WorldState__Sequence__copy(
  const gazebo_msgs__msg__WorldState__Sequence * input,
  gazebo_msgs__msg__WorldState__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(gazebo_msgs__msg__WorldState);
    gazebo_msgs__msg__WorldState * data =
      (gazebo_msgs__msg__WorldState *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!gazebo_msgs__msg__WorldState__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          gazebo_msgs__msg__WorldState__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!gazebo_msgs__msg__WorldState__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
