// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from gazebo_msgs:srv/ApplyLinkWrench.idl
// generated code does not contain a copyright notice

#ifndef GAZEBO_MSGS__SRV__DETAIL__APPLY_LINK_WRENCH__TRAITS_HPP_
#define GAZEBO_MSGS__SRV__DETAIL__APPLY_LINK_WRENCH__TRAITS_HPP_

#include "gazebo_msgs/srv/detail/apply_link_wrench__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

// Include directives for member types
// Member 'reference_point'
#include "geometry_msgs/msg/detail/point__traits.hpp"
// Member 'wrench'
#include "geometry_msgs/msg/detail/wrench__traits.hpp"
// Member 'start_time'
#include "builtin_interfaces/msg/detail/time__traits.hpp"
// Member 'duration'
#include "builtin_interfaces/msg/detail/duration__traits.hpp"

namespace rosidl_generator_traits
{

inline void to_yaml(
  const gazebo_msgs::srv::ApplyLinkWrench_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: link_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "link_name: ";
    value_to_yaml(msg.link_name, out);
    out << "\n";
  }

  // member: reference_frame
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "reference_frame: ";
    value_to_yaml(msg.reference_frame, out);
    out << "\n";
  }

  // member: reference_point
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "reference_point:\n";
    to_yaml(msg.reference_point, out, indentation + 2);
  }

  // member: wrench
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "wrench:\n";
    to_yaml(msg.wrench, out, indentation + 2);
  }

  // member: start_time
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "start_time:\n";
    to_yaml(msg.start_time, out, indentation + 2);
  }

  // member: duration
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "duration:\n";
    to_yaml(msg.duration, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const gazebo_msgs::srv::ApplyLinkWrench_Request & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<gazebo_msgs::srv::ApplyLinkWrench_Request>()
{
  return "gazebo_msgs::srv::ApplyLinkWrench_Request";
}

template<>
inline const char * name<gazebo_msgs::srv::ApplyLinkWrench_Request>()
{
  return "gazebo_msgs/srv/ApplyLinkWrench_Request";
}

template<>
struct has_fixed_size<gazebo_msgs::srv::ApplyLinkWrench_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<gazebo_msgs::srv::ApplyLinkWrench_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<gazebo_msgs::srv::ApplyLinkWrench_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

inline void to_yaml(
  const gazebo_msgs::srv::ApplyLinkWrench_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    value_to_yaml(msg.success, out);
    out << "\n";
  }

  // member: status_message
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status_message: ";
    value_to_yaml(msg.status_message, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const gazebo_msgs::srv::ApplyLinkWrench_Response & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<gazebo_msgs::srv::ApplyLinkWrench_Response>()
{
  return "gazebo_msgs::srv::ApplyLinkWrench_Response";
}

template<>
inline const char * name<gazebo_msgs::srv::ApplyLinkWrench_Response>()
{
  return "gazebo_msgs/srv/ApplyLinkWrench_Response";
}

template<>
struct has_fixed_size<gazebo_msgs::srv::ApplyLinkWrench_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<gazebo_msgs::srv::ApplyLinkWrench_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<gazebo_msgs::srv::ApplyLinkWrench_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<gazebo_msgs::srv::ApplyLinkWrench>()
{
  return "gazebo_msgs::srv::ApplyLinkWrench";
}

template<>
inline const char * name<gazebo_msgs::srv::ApplyLinkWrench>()
{
  return "gazebo_msgs/srv/ApplyLinkWrench";
}

template<>
struct has_fixed_size<gazebo_msgs::srv::ApplyLinkWrench>
  : std::integral_constant<
    bool,
    has_fixed_size<gazebo_msgs::srv::ApplyLinkWrench_Request>::value &&
    has_fixed_size<gazebo_msgs::srv::ApplyLinkWrench_Response>::value
  >
{
};

template<>
struct has_bounded_size<gazebo_msgs::srv::ApplyLinkWrench>
  : std::integral_constant<
    bool,
    has_bounded_size<gazebo_msgs::srv::ApplyLinkWrench_Request>::value &&
    has_bounded_size<gazebo_msgs::srv::ApplyLinkWrench_Response>::value
  >
{
};

template<>
struct is_service<gazebo_msgs::srv::ApplyLinkWrench>
  : std::true_type
{
};

template<>
struct is_service_request<gazebo_msgs::srv::ApplyLinkWrench_Request>
  : std::true_type
{
};

template<>
struct is_service_response<gazebo_msgs::srv::ApplyLinkWrench_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // GAZEBO_MSGS__SRV__DETAIL__APPLY_LINK_WRENCH__TRAITS_HPP_
