// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from gazebo_msgs:srv/GetModelProperties.idl
// generated code does not contain a copyright notice

#ifndef GAZEBO_MSGS__SRV__DETAIL__GET_MODEL_PROPERTIES__TRAITS_HPP_
#define GAZEBO_MSGS__SRV__DETAIL__GET_MODEL_PROPERTIES__TRAITS_HPP_

#include "gazebo_msgs/srv/detail/get_model_properties__struct.hpp"
#include <stdint.h>
#include <rosidl_runtime_cpp/traits.hpp>
#include <sstream>
#include <string>
#include <type_traits>

namespace rosidl_generator_traits
{

inline void to_yaml(
  const gazebo_msgs::srv::GetModelProperties_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: model_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "model_name: ";
    value_to_yaml(msg.model_name, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const gazebo_msgs::srv::GetModelProperties_Request & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<gazebo_msgs::srv::GetModelProperties_Request>()
{
  return "gazebo_msgs::srv::GetModelProperties_Request";
}

template<>
inline const char * name<gazebo_msgs::srv::GetModelProperties_Request>()
{
  return "gazebo_msgs/srv/GetModelProperties_Request";
}

template<>
struct has_fixed_size<gazebo_msgs::srv::GetModelProperties_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<gazebo_msgs::srv::GetModelProperties_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<gazebo_msgs::srv::GetModelProperties_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

inline void to_yaml(
  const gazebo_msgs::srv::GetModelProperties_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: parent_model_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "parent_model_name: ";
    value_to_yaml(msg.parent_model_name, out);
    out << "\n";
  }

  // member: canonical_body_name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "canonical_body_name: ";
    value_to_yaml(msg.canonical_body_name, out);
    out << "\n";
  }

  // member: body_names
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.body_names.size() == 0) {
      out << "body_names: []\n";
    } else {
      out << "body_names:\n";
      for (auto item : msg.body_names) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: geom_names
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.geom_names.size() == 0) {
      out << "geom_names: []\n";
    } else {
      out << "geom_names:\n";
      for (auto item : msg.geom_names) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: joint_names
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.joint_names.size() == 0) {
      out << "joint_names: []\n";
    } else {
      out << "joint_names:\n";
      for (auto item : msg.joint_names) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: child_model_names
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.child_model_names.size() == 0) {
      out << "child_model_names: []\n";
    } else {
      out << "child_model_names:\n";
      for (auto item : msg.child_model_names) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: is_static
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "is_static: ";
    value_to_yaml(msg.is_static, out);
    out << "\n";
  }

  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    value_to_yaml(msg.success, out);
    out << "\n";
  }

  // member: status_message
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "status_message: ";
    value_to_yaml(msg.status_message, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const gazebo_msgs::srv::GetModelProperties_Response & msg)
{
  std::ostringstream out;
  to_yaml(msg, out);
  return out.str();
}

template<>
inline const char * data_type<gazebo_msgs::srv::GetModelProperties_Response>()
{
  return "gazebo_msgs::srv::GetModelProperties_Response";
}

template<>
inline const char * name<gazebo_msgs::srv::GetModelProperties_Response>()
{
  return "gazebo_msgs/srv/GetModelProperties_Response";
}

template<>
struct has_fixed_size<gazebo_msgs::srv::GetModelProperties_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<gazebo_msgs::srv::GetModelProperties_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<gazebo_msgs::srv::GetModelProperties_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<gazebo_msgs::srv::GetModelProperties>()
{
  return "gazebo_msgs::srv::GetModelProperties";
}

template<>
inline const char * name<gazebo_msgs::srv::GetModelProperties>()
{
  return "gazebo_msgs/srv/GetModelProperties";
}

template<>
struct has_fixed_size<gazebo_msgs::srv::GetModelProperties>
  : std::integral_constant<
    bool,
    has_fixed_size<gazebo_msgs::srv::GetModelProperties_Request>::value &&
    has_fixed_size<gazebo_msgs::srv::GetModelProperties_Response>::value
  >
{
};

template<>
struct has_bounded_size<gazebo_msgs::srv::GetModelProperties>
  : std::integral_constant<
    bool,
    has_bounded_size<gazebo_msgs::srv::GetModelProperties_Request>::value &&
    has_bounded_size<gazebo_msgs::srv::GetModelProperties_Response>::value
  >
{
};

template<>
struct is_service<gazebo_msgs::srv::GetModelProperties>
  : std::true_type
{
};

template<>
struct is_service_request<gazebo_msgs::srv::GetModelProperties_Request>
  : std::true_type
{
};

template<>
struct is_service_response<gazebo_msgs::srv::GetModelProperties_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // GAZEBO_MSGS__SRV__DETAIL__GET_MODEL_PROPERTIES__TRAITS_HPP_
